#ifndef ARRAY_H
#define ARRAY_H

#include "types.h"

#define defineArrayType(TYPE) \
	typedef struct{ \
		TYPE* item; \
		UInt32 length; \
	} TYPE##Array_content; \
	typedef TYPE##Array_content* TYPE##Array; \
	 \
	TYPE##Array TYPE##Array_new(){ \
		TYPE##Array self=(TYPE##Array)calloc(sizeof(TYPE##Array_content),1); \
		return self; \
	} \
	 \
	void TYPE##Array_delete(TYPE##Array self){ \
		UInt32 i; \
		for(i=0;self->length && i<self->length;i++) \
			TYPE##_delete(self->item[i]); \
		 \
		if(self->length){ \
			free((Object)self->item); \
			self->item = null; \
		} \
		free((Object)self); \
	} \
	 \
	void TYPE##Array_resize(TYPE##Array self, UInt32 newLength){ \
		UInt32 i; \
		if(newLength==self->length) \
			return; \
		if(newLength<self->length){ \
			for(i=self->length-1;i>=newLength;i--) \
				TYPE##_delete(self->item[i]); \
		} \
		if(!self->length) \
			self->item=instanceArrayValue(TYPE,newLength); \
		else if(!newLength){ \
			free((Object)self->item); \
			self->item = null; \
		}else \
			self->item=(TYPE*)realloc((Object)self->item,newLength*sizeof(TYPE)); \
		for(i=self->length;i<newLength;i++) \
			self->item[i]=(TYPE)0; \
		 \
		 self->length=newLength; \
	} \
	 \
	void TYPE##Array_push(TYPE##Array self, TYPE item){ \
		TYPE##Array_resize(self,self->length+1); \
		self->item[self->length-1]=item; \
	}

#endif