#include <stdlib.h>
#include <stdio.h>

#include "types.h"
#include "array.h"
#include "stream.h"

#include "stringarray.h"
#include "stringarrayarray.h"

#include "uint32array.h"
#include "uint32arrayarray.h"

UInt32ArrayArray readMetaFile(String path){
	StringArray searchTerms=new (StringArray);
	StringArrayArray searchResults;
	UInt32ArrayArray searchResults32;
	String haystack;
	
	Stream inputFile=Stream_new_readableFromFile(path);
	haystack = Stream_readAllToString(inputFile);
	delete (inputFile ,Stream);
	
	StringArray_push(searchTerms,String_new_fromLiteral("Vertices = "));
	StringArray_push(searchTerms,String_new_fromLiteral("Indices = "));
	StringArray_push(searchTerms,String_new_fromLiteral("StartIndex = "));
	StringArray_push(searchTerms,String_new_fromLiteral("BaseIndex = "));
	
	searchResults = StringArray_findAndReturnToEndOfLine(searchTerms,haystack);
	delete(searchTerms ,StringArray);
	delete(haystack ,String);
	
	searchResults32 = UInt32ArrayArray_new_fromStringArrayArray(searchResults);
	delete(searchResults ,StringArrayArray);
	
	return searchResults32;
}

int main(int argc,String* argv){
	unsigned char c;
	Stream in=fopen(argv[1],"rb");
	UInt32 currentChunk=0;
	UInt32ArrayArray metaContent = readMetaFile(argv[2]);
	UInt32 verts = metaContent->item[0]->item[0];
	UInt32 indices = metaContent->item[1]->item[0] /3;
	UInt32 i=0;
	float* vertBuffer=(float*)malloc(32);
	UInt16* idxBuffer=(UInt16*)malloc(6);
	
	
	for(i=0;i<verts;i++){
		fread ((Object)vertBuffer,4, 8,in);
		printf("v %f %f %f\n",vertBuffer[0],vertBuffer[2],vertBuffer[1]);
		printf("vn %f %f %f\n",vertBuffer[3],vertBuffer[5],vertBuffer[4]);
	}
	
	for(i=0;i<indices;i++){
		fread ((Object)idxBuffer,2,3,in);
		
		printf("f %i//%i %i//%i %i//%i\n"
			, idxBuffer[0]+1+metaContent->item[3]->item[currentChunk]
			, idxBuffer[0]+1+metaContent->item[3]->item[currentChunk]
			, idxBuffer[1]+1+metaContent->item[3]->item[currentChunk]
			, idxBuffer[1]+1+metaContent->item[3]->item[currentChunk]
			, idxBuffer[2]+1+metaContent->item[3]->item[currentChunk]
			, idxBuffer[2]+1+metaContent->item[3]->item[currentChunk]
		);

		if(currentChunk<(metaContent->item[2]->length-1) && i>=(metaContent->item[2]->item[currentChunk+1]/3))
			currentChunk++;
	}
	
	delete(metaContent,UInt32ArrayArray);
	free(vertBuffer);
	free(idxBuffer);
	fclose(in);
}