#ifndef STREAM_H
#define STREAM_H

#include <stdio.h>

#include "types.h"

typedef FILE* Stream;
typedef FILE FILE_content;
#define Stream_new() ERROR_STREAMS_CANT_BE_CREATED_UNINITIALIZED
#define Stream_new_readableFromFile(path) fopen(path,"rb")
#define Stream_new_readableTextFromFile(path) fopen(path,"r")
#define Stream_new_writeableFromFile(path) fopen(path,"wb")
#define Stream_new_writeableTextFromFile(path) fopen(path,"w")
#define Stream_delete(self) fclose(self)

#define Stream_seek(self,offset) fseek(self, offset, SEEK_SET )
#define Stream_seekfromEnd(self,offset) fseek(self, offset, SEEK_END )
#define Stream_getPosition(self) ftell(self)
#define Stream_readBlocksToBuffer(self,blockSize,blockNumber,target) fread(target,blockSize,blockNumber,self)
#define Stream_readBytesToBuffer(self,len,target) Stream_readBlocksToBuffer(self,1,len,target)

UInt32 Stream_size(Stream self){
	UInt32 len;
	UInt32 orig=Stream_getPosition(self);
	Stream_seekfromEnd( self, 0 );
	len=Stream_getPosition(self);
	Stream_seek ( self, orig );
	return len;
}

Object Stream_readBytes(Stream self, UInt32 len){
	Object content=(Object)malloc(len);
	Stream_readBytesToBuffer(self,len,content);
	return content;
}

String Stream_readAllToString(Stream self){
	UInt32 sz=Stream_size(self);
	String content=(String)malloc(sz+1);
	Stream_seek ( self, 0 );
	fread ((Object)content,1, sz,self);
	content[sz]='\0';
	return content;
}



#endif