#ifndef TYPES_H
#define TYPES_H

void nop(){}
	
typedef unsigned long long int UInt64;
#define UInt64_delete(self) nop()
typedef signed long long int Int64;
#define Int64_delete(self) nop()
typedef unsigned long int UInt32;
#define UInt32_delete(self) nop()
typedef signed long int Int32;
#define Int32_delete(self) nop()
typedef unsigned short int UInt16;
#define UInt16_delete(self) nop()
typedef signed short int Int16;
#define Int16_delete(self) nop()
typedef unsigned char UInt8;
#define UInt8_delete(self) nop()
typedef signed char Int8;
#define Int8_delete(self) nop()
typedef signed char Boolean;
#define Boolean_delete(self) nop()

#define new(type) (type##_new())
#define delete(name,type) (type##_delete(name))
#define false 0
#define true 1
#define null ((Object)0)

typedef void* Object;
typedef void Object_content;
#define Object_new() null
void Object_delete(Object self){ if(self!=null) free(self); }

typedef char* String;
typedef char String_content;
char* String_new(){ return (char*)calloc(1,1); }
#define String_new_fromLiteral(lit) (strdup(lit))
#define String_delete(self) Object_delete((Object)self)

#define String_length(self) strlen(self)

#define instanceArrayValue(type,length) (type*)calloc(sizeof(type)*length,1)

#endif